<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:foaf="http://xmlns.com/foaf/0.1/" xmlns:cm="http://chefmoz.org/rdf/elements/1.0/" xmlns:html="http://www.w3.org/TR/REC-html40" version="1.0" result-ns="xml">
<!--   hacked by danbri to emit RDF 
	see http://esw.w3.org/topic/RestaurantRecommendation
	-->
  <xsl:output method="xml" indent="yes" encoding="ISO-8859-1" media-type="application/rdf+xml"/>
  <xsl:template match="/">
    <rdf:RDF>
      <xsl:apply-templates select="agenda"/>
    </rdf:RDF>
  </xsl:template>
  <xsl:template match="entry">
<!-- a Restaurant entry -->
    <xsl:element name="cm:Restaurant">
      <xsl:element name="cm:x-category">
        <xsl:value-of select="type"/>
      </xsl:element>
      <xsl:element name="cm:x-Address">
        <xsl:if test="url">
          <xsl:value-of select="url"/>
          <xsl:value-of select="name"/>
        </xsl:if>
        <xsl:if test="not(url)">
          <xsl:value-of select="name"/>
        </xsl:if>
        <xsl:value-of select="city"/>
        <xsl:value-of select="address"/>
      </xsl:element>
      <xsl:element name="cm:Phone">
        <xsl:value-of select="tel"/>
      </xsl:element>
      <xsl:element name="cm:Price">
        <xsl:value-of select="price"/>
      </xsl:element>
      <xsl:apply-templates select="rating">
        <xsl:sort select="@by"/>
      </xsl:apply-templates>
    </xsl:element>
  </xsl:template>
  <xsl:template match="rating">
    <xsl:element name="cm:x-rating">
      <xsl:element name="cm:x-Review">
        <xsl:element name="cm:x-note">
          <xsl:value-of select="note"/>
        </xsl:element>
        <xsl:element name="cm:comments">
          <xsl:value-of select="comments"/>
        </xsl:element>
        <xsl:element name="cm:x-reviewerMail">
          <xsl:attribute name="rdf:resource">mailto:<xsl:value-of select="email"/></xsl:attribute>
        </xsl:element>
        <xsl:element name="cm:reviewer-name">
          <xsl:value-of select="ancestor::entry/name"/>
        </xsl:element>
        <xsl:element name="cm:reviewer-by">
          <xsl:value-of select="@by"/>
        </xsl:element>
        <xsl:element name="cm:x-date">
          <xsl:value-of select="date"/>
        </xsl:element>
      </xsl:element>
    </xsl:element>
  </xsl:template>
  <xsl:template match="links">
    <xsl:for-each select="link">
      <xsl:element name="foaf:Document">
        <xsl:attribute name="rdf:about">
          <xsl:value-of select="@url"/>
        </xsl:attribute>
        <xsl:element name="dc:title">
          <xsl:value-of select="."/>
        </xsl:element>
      </xsl:element>
    </xsl:for-each>
  </xsl:template>
</xsl:stylesheet>
