#!/usr/bin/env ruby

# RDF query (in memory version), Dan Brickley <danbri@w3.org> 

$LOAD_PATH.unshift '../lib/'

require 'test/unit'

require 'basicrdf'
require 'squish'

class TC_MemorySquishTest < Test::Unit::TestCase

  attr_accessor :q, :resultset

  def setup
    @q = SquishQuery.new.parseFromText 'SELECT ?item, ?title, ?etype, ?org, ?log, 
	FROM events.xml 
	WHERE 
	(rss::title ?item ?title) 
	(ev::type ?item ?etype)
	(ev::organizer ?item ?org)
        (ev::location ?item ?loc)
	USING
	rss for http://purl.org/rss/1.0/
	ev for http://purl.org/rss/1.0/modules/event/'

    @resultset=nil

    #    @resultset=SquishQuery.ask(@q, Loader.get_rdf(@q.from_args, 'http://events.example.org/'))
    @resultset=SquishQuery.ask(@q, Loader.get_rdf(@q.from_args))
  end

  def test_eventquery
    # puts "WTF?!: #{self.inspect}"
    assert(@resultset != nil ,"There should be a resultset")
    assert(@resultset.size==17,"There should be 17 results")
  end

  def teardown 
    @resultset = nil
    @q = nil
  end

end




    # puts "Query: \n#{q.inspect} \n\n"
    # @resultset.each do |row|
    #  row.values.each_key do |field| puts "#{field}: #{row.values[field]} \n" end
    #   puts "\n\n"
    # end
