#!/usr/bin/env ruby

$LOAD_PATH.unshift '../lib/' 		
$LOAD_PATH.unshift '../../lib/' 		
$LOAD_PATH.unshift './net/' 		

# Testing toSQLInserts() method
# Dan Brickley <danbri@w3.org>
# $Id: tc_sqlgen.rb,v 1.3 2003/04/18 18:06:12 danbri Exp $

require 'test/unit'
require 'basicrdf'

class TC_SQLGen < Test::Unit::TestCase
  def setup
    # fetch data here instead?
  end

  def test_fgrub
    #u1='http://www.w3.org/2001/12/rubyrdf/pack/tests/net/s1.rdf'
    u1='http://the.earth.li/~kake/cgi-bin/cgi-wiki/wiki.cgi?action=rss&feed=chef_moz&id=Cittie_Of_Yorke,_WC1V_6BN'
    d=Loader.get_rdf_from_uri u1, u1
    # 1046910663 appears in subjects of triples but not in resources

    u2='http://the.earth.li/~kake/cgi-bin/cgi-wiki/wiki.cgi?Cittie_Of_Yorke%2C_WC1V_6BN'
    n1=Node.new(u2)
    puts "U2 is: "+n1.sha1.to_s

    h1=1046910663	
    assert h1 == n1.sha1,"1046910663 is hash of #{u2} (actual: #{n1.sha1})"
    assert 12341234 != n1.sha1,"12341234 is NOT hash of #{u2} (actual: #{n1.sha1})"

    d.toSQLInserts('http://example.com/mydata').each do |i|
      puts "ADDING: #{i}"
    end
  end
end

