#!/usr/bin/env ruby
#
# Testing RubyRDF, http://www.w3.org/2001/12/rubyrdf/intro.html
# 
#  using TestUnit, see 
#  http://www.rubygarden.org/ruby?UsingTestUnit
#  http://testunit.talbott.ws/
#  http://www.rubyconf.com/2001/talks/testinginreverse/
#
# $Id: ts_gentletests.rb,v 1.3 2003/04/21 02:48:13 danbri Exp $
# Dan Brickley <danbri@w3.org>
#

# here we omit the hardcore rdf syntax tests

require 'test/unit'

# hmm order shouldn't matter, but does: (reverse 1st two)

require './memsquish'		# test in-memory RDF query engine (and parsing)
require './tc_fetchrdf' 	# test remote retrieval (and parsing)

require './_genq'
				# these depend on being online:
				# (should test for network and skip...)
require './net/tc_baseuri' 	# test base uri facilities
require './net/tc_grub'		# test load'n'query of remote data


require './dbi/tc_dbiutil'   # test ability to manage rdf stores via dbi
require './api/tc_basicapi'
require './scutter/sqlgraph' # poorly named Cwm-pastiche tests; needs scutter though.




# TODO: 
#  when the tests were loaded in reverse order, the first one failed. Why?!
# 
#  Add Syntax tests, my own, and RDF core (see ./syntax/, for eg nodeID work)
#  Add Query tests, generated from the new manifest format.
#    http://www.w3.org/2003/03/rdfqr-tests/
#
# Things to add:
#  Test SQL-backed query (Postgres,MySQL)
#  Test REXML RDF parser
#  Test XSLT RDF parser
#  Test basic RDF API
#  Test Node-centric API
